<template>
  <q-page class="q-px-md q-mt-md">
    <div class="row q-gutter-x-sm">
      <div class="col-md-12">
        <q-card class="q-px-sm ">
          <q-card-section class="q-py-none ">
            <h6 class="q-my-sm q-pt-md">
              รายการเล่นของสมาฃิก จากการฝากเงินล่าสุด
            </h6>
          </q-card-section>

          <q-card-section class="q-py-none">
            <StartDateEndDateFilterComponent :filter="dateFilter" />
          </q-card-section>
          <q-card-section class="q-py-sm">
            <q-input
              bg-color="grey-13"
              @keydown.enter="onSearch"
              v-model.trim="filter.username"
              placeholder="ค้นหา อย่างน้อย 3 ตัวอักษร"
              outlined
              dense
              style="width:400px"
            >
              <template v-slot:prepend>
                <q-icon name="search" class="pointer" />
              </template>
              <template v-slot:append>
                <q-icon
                  v-if="filter.username !== ''"
                  name="close"
                  @click="
                    e => {
                      filter.username = undefined;
                      onRequest({
                        pagination: pagination,
                        filter: filter
                      });
                    }
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:after>
                <q-btn color="green" @click.prevent="onSearch" icon="search"
                  >ค้นหา</q-btn
                >
              </template>
            </q-input>
          </q-card-section>
          <q-card-section class="q-py-sm">
            <div class="row">
              <div v-if="provider_table">
                <q-btn color="primary" @click="backToDefaultTable(0)"
                  >BACK
                </q-btn>
              </div>

              <div v-if="transaction_table">
                <q-btn color="primary" @click="backToDefaultTable(1)"
                  >BACK
                </q-btn>
              </div>
            </div>
          </q-card-section>

          <template>
            <div class="text-center" v-if="default_table">
              <q-table
                :rows-per-page-options="[15, 25, 50]"
                :pagination.sync="pagination"
                :loading="loading"
                :data="items"
                :columns="fields"
                separator="cell"
                row-key="id"
                @request="onRequest"
                flat
                bordered
              >
                <template slot="header" slot-scope="props" :props="props">
                  <q-tr>
                    <q-th
                      v-for="(col, index) in props.cols"
                      :key="index"
                      class="bg-light-blue-5 text-white"
                    >
                      {{ col.label }}
                    </q-th>
                  </q-tr>
                </template>
                <template slot="body" slot-scope="props" :props="props">
                  <q-tr v-if="props.row">
                    <q-td>
                      <q-btn
                        @click="searchProvider(props.row.grouped)"
                        flat
                        color="primary"
                      >
                        <span class="link-color"
                          ><u> {{ providerMap(props.row.grouped) }}</u></span
                        >
                      </q-btn>
                    </q-td>
                    <q-td>
                      {{ props.row.wagers }}
                    </q-td>
                    <q-td>
                      {{ props.row.turnover }}
                    </q-td>
                    <q-td>
                      {{ props.row.bet }}
                    </q-td>
                    <q-td>
                      {{ props.row.payout }}
                    </q-td>

                    <q-td>
                      {{ props.row.winlose }}
                    </q-td>
                  </q-tr>
                </template>
                <template v-slot:loading>
                  <q-inner-loading showing color="primary" />
                </template>
              </q-table>
            </div>

            <div class="text-center" v-if="provider_table">
              <q-table
                :rows-per-page-options="[15, 25, 50]"
                :pagination.sync="pagination"
                :loading="loading"
                :data="provider"
                :columns="provider_fields"
                separator="cell"
                row-key="id"
                @request="onRequest"
                flat
                bordered
              >
                <template slot="header" slot-scope="props" :props="props">
                  <q-tr>
                    <q-th
                      v-for="(col, index) in props.cols"
                      :key="index"
                      class="bg-light-blue-5 text-white"
                    >
                      {{ col.label }}
                    </q-th>
                  </q-tr>
                </template>
                <template slot="body" slot-scope="props" :props="props">
                  <q-tr>
                    <q-td>
                      <q-btn
                        @click="searchType(props.row.grouped)"
                        flat
                        color="primary"
                      >
                        <span class="link-color"
                          ><u> {{ gameTypeMap(props.row.grouped) }}</u></span
                        >
                      </q-btn>
                    </q-td>
                    <q-td>
                      {{ props.row.wagers }}
                    </q-td>
                    <q-td>
                      {{ props.row.turnover }}
                    </q-td>
                    <q-td>
                      {{ props.row.bet }}
                    </q-td>
                    <q-td>
                      {{ props.row.payout }}
                    </q-td>

                    <q-td>
                      {{ props.row.winlose }}
                    </q-td>
                  </q-tr>
                </template>
              </q-table>
            </div>
            <div class="text-center" v-if="transaction_table">
              <q-table
                :rows-per-page-options="[15, 25, 50]"
                :pagination.sync="pagination"
                :loading="loading"
                :data="transaction"
                :columns="transaction_fields"
                separator="cell"
                row-key="id"
                @request="onRequest"
                flat
                bordered
              >
                <template slot="header" slot-scope="props" :props="props">
                  <q-tr>
                    <q-th
                      v-for="(col, index) in props.cols"
                      :key="index"
                      class="bg-light-blue-5 text-white"
                    >
                      {{ col.label }}
                    </q-th>
                  </q-tr>
                </template>
                <template slot="body" slot-scope="props" :props="props">
                  <q-tr>
                    <q-td>
                      {{ gameTypeMap(props.row.product) }}
                    </q-td>

                    <q-td>
                      {{ providerMap(props.row.site) }}
                    </q-td>
                    <q-td>
                      {{ props.row.member }}
                    </q-td>
                    <q-td>
                      <a
                        v-if="props.row.historyUrl"
                        class="link-color"
                        :href="props.row.historyUrl"
                        target="_blank"
                      >
                        {{ parseDate(props.row.start_time) }}
                      </a>
                      <span v-else>
                        {{ parseDate(props.row.start_time) }}
                      </span>
                    </q-td>
                    <q-td>
                      {{ props.row.turnover }}
                    </q-td>
                    <q-td>
                      {{ props.row.bet }}
                    </q-td>
                    <q-td>
                      {{ props.row.winlose }}
                    </q-td>
                    <q-td>
                      {{ props.row.payout }}
                    </q-td>
                    <q-td>
                      <div v-if="props.row.status == 1">สำเร็จ</div>
                      <div v-if="props.row.status == 0">กำลังคิดผล</div>
                      <div v-if="props.row.status == -1">ยกเลิก</div>
                    </q-td>
                    <q-td>
                      {{ props.row.game_id }}
                    </q-td>
                  </q-tr>
                </template>
              </q-table>
            </div>
          </template>
        </q-card>
      </div>
    </div>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions, mapMutations } from "vuex";
import { SessionStorage, LocalStorage } from "quasar";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";
import { api } from "boot/axios";

import _ from "lodash";

const sessionKey = "filter_report_member_";
const username = LocalStorage.getItem("username");
export default {
  name: "Index",
  components: {
    StartDateEndDateFilterComponent
  },
  props: {
    isClick: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      data: [],
      downlineData: null,
      targetRole: null,
      loading: false,
      dateFilter: {
        startDate:
          new Date().getDate() !== 1
            ? new Date().setDate(1)
            : new Date(
                new Date().getFullYear(),
                new Date().getMonth() - 1
              ).setDate(1),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date().setDate(new Date().getDate() - 1),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      filter: {
        username: undefined,
        parent_id: undefined,
        level: undefined,
        step: 1
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 25,
        rowsNumber: 0
      },
      groupList: [],
      providerList: [],
      transactionModal: {
        modal: false,
        user: undefined,
        id: undefined
      },
      gotData: false,
      sumAmount: 0,
      error: false,
      rows: null,
      perPage: null,
      currentPage: 1,
      items: [],
      provider: [],
      transaction: [],
      default_table: true,
      provider_table: false,
      transaction_table: false,
      tempProvider: null,
      tempUserName: null,

      Form: {
        searchValue: null,
        FromDate: null,
        FromTime: null,
        ToDate: null,
        ToTime: null
      },
      deposit: {
        amount: null,
        created_at: null,
        bonusamount: null,
        topupby: null
      },

      tableTitle: "รายการสมัครสมาชิก",
      fields: [
        { key: "grouped", label: "ค่ายเกม" },
        { key: "wagers", label: "จำนวนครั้งในการเดิมพัน" },
        { key: "turnover", label: "turnover" },
        { key: "bet", label: "วางเดิมพัน" },
        { key: "payout", label: "ค่ายเกมส์จ่าย" },
        { key: "winlose", label: "แพ้ชนะ" }
      ],
      provider_fields: [
        { key: "grouped", label: "ประเภทเกมส์" },
        { key: "wagers", label: "จำนวนครั้งในการเดิมพัน" },
        { key: "turnover", label: "turnover" },
        { key: "bet", label: "วางเดิมพัน" },
        { key: "payout", label: "ค่ายเกมส์จ่าย" },
        { key: "winlose", label: "แพ้ชนะ" }
      ],
      transaction_fields: [
        { key: "product", label: "ประเภทเกมส์" },
        { key: "site", label: "ค่ายเกมส์" },
        { key: "member", label: "username" },
        { key: "start_time", label: "เวลา" },
        { key: "bet_detail", label: "รายละเอียด" },
        { key: "bet", label: "เดิมพัน" },
        { key: "payout", label: "จ่าย" },
        { key: "winlose", label: "แพ้ชนะ" },
        { key: "status", label: "สถานะการคิดผล" },
        { key: "game_name", label: "เกมส์ที่เล่น" }
      ],
      gameTypeObj: {
        SL: "SLOT",
        LC: "LIVE-CASINO",
        SB: "SPORTBOOK",
        OT: "OTHERS",
        ES: "ESPORT",
        LK: "LOTTO",
        PK: "POKER",
        FH: "FISHING",
        CB: "CARD & BOARD",
        MG: "MINI GAME"
      },
      providerObj: {
        AB: "Allbet",
        AG: "ASIA GAMING",
        CQ: "CQ9",

        AV: "AVIA Gaming",
        CB: "CitiBet",
        DG: "Dream Gaming",
        FG: "Fun Gaming",
        FI: "Maverick",
        F5: "Maverick",
        GE: "Evolution Gaming",
        GM: "Gamatron",
        GT: "BTI",
        L4: "LIVE22",
        PG: "PG Soft",
        PR: "Pragmatic Play",
        PX: "Playtech",
        S2: "Sexy Baccarat",
        SG: "Spade Gaming",
        SO: "SBO",
        SY: "Simple Play",
        VV: "Vivo Gaming",
        WB: "Wbet",

        AM: "Ameba",
        CQ: "CQ9",
        EP: "Evoplay",
        JK: "Joker",
        SA: "SA Gaming",
        RE: "Red Tiger"
      }
    };
  },

  async created() {
    document.title = "Report";
    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
      this.game_type = this.groupList
        .filter(
          (item, index) =>
            this.groupList.findIndex(r => r.code == item.code) == index
        )
        .map(x => x.code);
    } else {
      try {
        const {
          data: { results }
        } = await this.load_list();
        if (results) {
          this.groupList = results.filter(
            (item, index) =>
              results.findIndex(r => r.code == item.code) == index
          );
          SessionStorage.set("group_list_filter", this.groupList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }

    // if (
    //   this.$route.path !== "/v2/report/member" &&
    //   !this.$route.query.company
    // ) {
    //   await this.onSearch();
    // }
  },

  computed: {
    ...mapState("auth", ["role,username"]),
    ...mapGetters("report/v2", {
      settingData: "getDateTime"
    }),
    numberFormat() {
      return (number, digit = 2, comma = true) =>
        new Intl.NumberFormat("en-US", {
          minimumFractionDigits: digit,
          maximumFractionDigits: digit,
          useGrouping: comma
        }).format(number);
    },
    convertToFloat() {
      return number => parseFloat(this.numberFormat(number, 2, false));
    },
    bgFunc() {
      return inValue => {
        const value = this.convertToFloat(inValue.replace(/,/g, ""));

        if (value > 0) {
          return "text-green-8 text-bold";
        }
        if (value == 0) {
          return "";
        }
        return "text-red-10 text-bold";
      };
    }
  },

  methods: {
    ...mapActions("report/v2", [
      "getAllReport",
      "getOrganizationById",
      "getOrganization"
    ]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    ...mapMutations("report/v2", ["setDateTime", "setGameType", "setProvider"]),
    backToDefaultTable(value) {
      if (value == 0 && this.gotData) {
        this.provider_table = false;
        this.default_table = true;
        this.transaction_table = false;
      } else if (value == 1 && this.gotData) {
        this.provider_table = true;
        this.default_table = false;
        this.transaction_table = false;
      } else {
        if (value == 2 && this.gotData) {
          this.provider_table = false;
          this.default_table = false;
          this.transaction_table = true;
        }
      }
    },
    gameTypeMap(code) {
      return this.gameTypeObj[code];
    },
    providerMap(code) {
      return this.providerObj[code];
    },
    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
    },
    getFilterParameter({ filter = this.filter, pagination = this.pagination }) {
      if (this.$route.meta.level) {
        filter.level = this.$route.meta.level;
      }
      if (this.$route.params.id) {
        filter.parent_id = this.$route.params.id;
      } else {
        delete filter.parent_id;
      }
      let start = undefined;
      let end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }

      return {
        // ...filter,
        // ...pagination,
        search: filter.username,
        page: pagination.page,
        limit: pagination.rowsPerPage,
        typeCode: this.game_type.join(",")
          ? this.game_type.join(",")
          : undefined,
        providerCode: this.provider_code.join(",")
          ? this.provider_code.join(",")
          : undefined,
        start: new Date(start).toISOString(),
        end: new Date(end).toISOString()
      };
    },
    async onRequest(props) {
      try {
        this.$q.loading.show();

        const parameters = this.getFilterParameter(props);

        if (!parameters.search) {
          this.$dialog.alert("กรูณาใส่ userName");

          this.$q.loading.hide();

          return;
        }
        const { data } = await api.post(
          `/api/Realtime/V2`,
          {
            username: parameters.search,
            starttime: parameters.start,
            endtime: parameters.end,
            provider: null,
            type: null
          },
          {
            headers: {
              username: username
            }
          }
        );
        this.tempUserName = parameters.search;

        this.items = data.stats;
        this.deposit = data.dp;

        this.gotData = true;

        this.$q.loading.hide();
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
      this.$q.loading.hide();
    },
    async onSearch() {
      this.gotData = false;
      this.provider_table = false;
      this.default_table = true;
      this.transaction_table = false;
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    },

    numberWithCommas(x) {
      var parts = x.toString().split(".");
      parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
      return parts.join(".");
    },
    parseDate(value) {
      if (value) {
        try {
          if (dayjs(value).isValid()) {
            return dayjs(value).format("DD-MM-YYYY HH:mm:ss");
          }
          // return new Date(value.replace(/\//g, "")).format("DD/MM/YYYY HH:mm:ss");
          return dayjs(parseInt(value.replace(/[^0-9]/g, "")))
            .add(1, "hour")
            .utc(true)
            .local()
            .format("DD-MM-YYYY HH:mm:ss");
        } catch {}
      }
      return "-";
    },
    async searchProvider(provider) {
      this.$q.loading.show();

      this.gotData = false;

      this.provider_table = true;
      this.default_table = false;
      this.transaction_table = false;

      this.tempProvider = provider;
      const parameters = this.getFilterParameter({
        pagination: this.pagination,
        filter: this.filter
      });

      try {
        const data = await api.post(`/api/Realtime/V2`, {
          username: this.tempUserName,
          starttime: parameters.start,
          endtime: parameters.end,
          provider: provider,
          type: null
        });

        this.provider = data.data.stats;
        this.gotData = true;
      } catch (error) {
        this.$dialog.errorException(error);
      }
      this.$q.loading.hide();
    },
    async searchType(type_game) {
      this.$q.loading.show();

      this.gotData = false;
      let tempFrom = this.Form.FromDate + "T" + this.Form.FromTime;
      this.provider_table = false;
      this.default_table = false;
      this.transaction_table = true;

      const parameters = this.getFilterParameter({
        pagination: this.pagination,
        filter: this.filter
      });
      try {
        // const { data } = await axios.post(`/api/Realtime`, {params: {...this.Form}});
        let data2 = await api.post(`/api/Realtime/V2`, {
          username: this.tempUserName,

          starttime: parameters.start,
          endtime: parameters.end,
          provider: this.tempProvider,
          type: type_game
        });

        this.transaction = data2.data.stats;
        this.perPage = 20;
        this.rows = this.transaction.length;
        this.gotData = true;
      } catch (error) {
        this.$dialog.errorException(error);
      }
      this.$q.loading.hide();
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
